def bond(result_layer, cell_result,strip_width,bond_shift)
                    @ep = RBA::EdgeProcessor::new
                    @cell_result = cell_result
                    @result_layer = result_layer
                    @a = [ RBA::Polygon::from_s("(-6960,-3380;-2960,-3380;40,0;-2960,3380;-6960,3380)") ]
                    @b = [ RBA::Polygon::from_s("(-5960,-1500;-2960,-1500;40,0;-2960,1500;-5960,1500)") ]
# Run an XOR -> creates a polygon with a hole, since the 'resolve_holes' parameter
# is false:
# you can also use insert_hole to make a hole in a polygon
                    @outP = @ep.boolean_p2p(@a, @b, RBA::EdgeProcessor::ModeXor, false, false)
                    #snip edge to match connecting trace
                    @snip=[RBA::Polygon::new(RBA::Box::new(-bond_shift,-strip_width/2,40,strip_width/2) )]
                    @outP = @ep.boolean_p2p(@outP, @snip, RBA::EdgeProcessor::ModeANotB, false, false)
                    
                    @outP.each { |i|  @cell_result.shapes(@result_layer).insert(i) }
                    return(@outP)
end

def waveguide(result_layer, cell_result, path_string, strip_width, gap)
#path string is a string representing the coordinates
  @cell_result=cell_result
  @path1=RBA::Path::from_s(path_string)
  @path1.width=strip_width
  @path2=@path1.dup
  @path2.width=gap
  @ep=RBA::EdgeProcessor::new
  @outP = @ep.boolean_p2p([@path1.polygon],[@path2.polygon], RBA::EdgeProcessor::ModeXor, false, true)
  @outP.each { |i|  @cell_result.shapes(result_layer).insert(i) }
  return(@outP)
end

#My first attempt at overloading a class with a new method. This method is a simple way to get a cell reference with no
#translation
class RBA::Cell
  def ref
  return(RBA::CellInstArray::new(cell_index,RBA::CplxTrans::new))
  end
end

def marker(marker_width,marker_length, cell_name, layer_name,corner_dim,layout)
  @layout=layout
  @marker_cell = @layout.create_cell(cell_name)
  @marker_cell.shapes(layer_name).insert(RBA::Box::new(-marker_length, -marker_width, marker_length,marker_width))
  @marker_cell.shapes(layer_name).insert(RBA::Box::new(-marker_width,-marker_length, marker_width,marker_length))
  @corner=RBA::Box::new(-corner_dim,-corner_dim,corner_dim,corner_dim)
  @corner.move(marker_length,marker_length)
  @marker_cell.shapes(layer_name).insert(@corner)
  return @marker_cell
end